require 'dreader'

i = Dreader::Engine.new

i.options do
  first_row 2
end

i.column :name do
  colref 'A'
end

i.column :birthdate do
  colref 'B'

  process do |c|
    Date.parse(c)
  end
end

i.virtual_column :age do
  process do |row|
    birthdate = row[:birthdate][:value]
    birthday = Date.new(Date.today.year, birthdate.month, birthdate.day)
    today = Date.today

    [0, today.year - birthdate.year - (birthday < today ? 1 : 0)].max
  end
end

i.mapping do |row|
  r = Dreader::Util.simplify(row)
  puts "#{r[:name]} is #{r[:age]} years old (born on #{r[:birthdate]})"
end

i.read filename: "Birthdays.ods"
i.virtual_columns
i.process

